import { AxiosRequestConfig } from 'axios';
export type SEPAConfig = Partial<{
    "host": string;
    "oauth": {
        "enable": boolean;
        "register": string;
        "tokenRequest": string;
    };
    "sparql11protocol": {
        "protocol": "http" | "https";
        "port": number;
        "query": {
            "path": string;
            "method": "POST" | "GET";
            "format": "JSON";
        };
        "update": {
            "path": "/update";
            "method": "POST" | "GET";
            "format": "JSON";
        };
    };
    "sparql11seprotocol": {
        "protocol": "ws" | "wss";
        "availableProtocols": Record<"ws" | "wss", {
            port: number;
            path: string;
        }>;
    };
    "options": AxiosRequestConfig;
}>;
declare const _default: Readonly<Partial<{
    host: string;
    oauth: {
        enable: boolean;
        register: string;
        tokenRequest: string;
    };
    sparql11protocol: {
        protocol: "http" | "https";
        port: number;
        query: {
            path: string;
            method: "GET" | "POST";
            format: "JSON";
        };
        update: {
            path: "/update";
            method: "GET" | "POST";
            format: "JSON";
        };
    };
    sparql11seprotocol: {
        protocol: "ws" | "wss";
        availableProtocols: Record<"ws" | "wss", {
            port: number;
            path: string;
        }>;
    };
    options: AxiosRequestConfig;
}>>;
export default _default;
