import defaults from './defaults';
import { Bindings } from './querybench';
export type JSAPConfig = Partial<typeof defaults> & {
    namespaces?: Record<string, string>;
    extended?: Record<string, any>;
    updates?: Record<string, any>;
    queries?: Record<string, any>;
};
declare class Jsap {
    #private;
    namespaces: Record<string, string>;
    extended: Record<string, any>;
    updates: Record<string, any>;
    queries: Record<string, any>;
    constructor(config?: JSAPConfig | string);
    query(key: string, bindings: Bindings): Promise<any>;
    subscribe(key: string, bindings: Bindings): import("./subscription").default;
    update(key: string, bindings: Bindings): Promise<{
        status: number;
        statusText: string;
    }>;
    producer(key: string): (binds: any) => void;
    consumer(key: string): (binds: any) => void;
    get Producers(): {};
    get Consumers(): {};
}
type Tail<T> = T extends (ignored: infer _, ...args: infer P) => infer ReturnType ? (...args: P) => ReturnType : never;
type DynamicJsap = new <T extends JSAPConfig>(attr: T) => Jsap & Record<keyof T["updates"], Tail<Jsap["update"]>> & Record<keyof T["queries"], (Tail<Jsap["subscribe"]> & Tail<{
    query: Jsap["query"];
}>)>;
declare const _default: DynamicJsap;
export default _default;
