export type URIBinding = {
    type: "uri";
    value: string | string[] | null;
};
export type LiteralBinding = {
    type: "literal";
    value: string | number | boolean | (string | number | boolean)[] | null;
};
export type Binding = URIBinding | LiteralBinding;
export type Bindings = Record<string, Binding> | Array<Record<string, Binding>>;
export default class SPARQLbench {
    private namespaces;
    constructor(namespaces?: Record<string, string>);
    addNameSpace(prefix: string, ns: string): void;
    removeNameSpace(prefix: string): void;
    sparql(template: string, bindings: Bindings): string;
    private _isquery;
    private _transformValue;
    private _createValueTemplate;
    private _createValues;
}
