import { SEPAConfig } from './defaults';
import Subscription from './subscription';
export default class SEPA {
    private _config;
    private queryURI;
    private updateURI;
    private connectionPool;
    private subscribeURI;
    private _wsFactory;
    get config(): Partial<{
        host: string;
        oauth: {
            enable: boolean;
            register: string;
            tokenRequest: string;
        };
        sparql11protocol: {
            protocol: "http" | "https";
            port: number;
            query: {
                path: string;
                method: "GET" | "POST";
                format: "JSON";
            };
            update: {
                path: "/update";
                method: "GET" | "POST";
                format: "JSON";
            };
        };
        sparql11seprotocol: {
            protocol: "ws" | "wss";
            availableProtocols: Record<"ws" | "wss", {
                port: number;
                path: string;
            }>;
        };
        options: import("axios").AxiosRequestConfig;
    }>;
    constructor(parameters: SEPAConfig);
    query(query: string, config: SEPAConfig): Promise<any>;
    update(update: string, config: SEPAConfig): Promise<{
        status: number;
        statusText: string;
    }>;
    subscribe(query: string, config: SEPAConfig, alias?: string): Subscription;
}
